﻿using System;
using System.Drawing;
using System.Windows.Forms;
using TopoR_PCB_Classes;

namespace TopoRAdd
{
    public partial class RenameForm : Form
    {

        public RenameForm()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Проверка возможности переименовывание или переименовывание компонентов
        /// </summary>
        /// <param name="check">true - только проверка</param>
        /// <returns>имя существуещего или пустая строка</returns>
        private string _chekAndRename(bool check)
        {
            foreach (ComponentsOnBoard.CompInstance a in (Owner as MainWindow).lbComponents.SelectedItems)
            {
                string newname = tb_rename.Text.Trim();
                if (newname == "")
                {
                    newname = a._name;
                }
                newname = tb_pre.Text.Trim() + newname + tb_post.Text.Trim();
                if ((int)(nu_start.Value + nu_end.Value) < newname.Length)
                {
                    newname = newname.Substring((int)nu_start.Value, newname.Length - (int)(nu_start.Value + nu_end.Value));
                }
                if ((Owner as MainWindow).docFST._ComponentsOnBoard.ComponentIndexOf(newname) != -1)
                {
                    return newname;
                }
                if (!check)
                {
                    (Owner as MainWindow).docFST.RenameComponent(a._name, newname);
                }
            }
            return null;
        }
        private void btOk_Click(object sender, EventArgs e)
        {
            string check = _chekAndRename(true);
            if (check != "")
            {
                MessageBox.Show("Неуникальное имя: " + check + " ! Переименование невозможно.");
            }
            else
            {
                _chekAndRename(true);
                DialogResult = DialogResult.OK;
            }
        }

        private void RenameForm_Load(object sender, EventArgs e)
        {
            if ((Owner as MainWindow).lbComponents.SelectedItems.Count > 1)
            {
                gb_rename.Enabled = false;
            }
            else
            {
                tb_rename.Text = ((Owner as MainWindow).lbComponents.SelectedItem as ComponentsOnBoard.CompInstance)._name;
            }
        }

        private void tb_rename_TextChanged(object sender, EventArgs e)
        {
            if ((Owner as MainWindow).docFST._ComponentsOnBoard?.ComponentIndexOf(tb_rename.Text) != -1)
            {
                tb_rename.ForeColor = Color.Red;
                lbError.Text = "такое имя уже есть";
            }
            else
            {
                tb_rename.ForeColor = Color.Black;
                lbError.Text = "";
            }
        }
    }
}
